unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PlugIn;

type
  TfrmMain = class(TForm)
    lstTest: TListBox;
    btnAdd: TButton;
    txtAdd: TEdit;
    btnDelete: TButton;
    cmbType: TComboBox;
    procedure cmbTypeChange(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FPlugIns: TList;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.cmbTypeChange(Sender: TObject);
var
  P: TPlugIn;
begin
  if cmbType.ItemIndex = 0 then
  begin
    lstTest.ItemHeight := 13;
    lstTest.Style := lbStandard;
  end
  else
  begin
    P := TPlugIn(cmbType.Items.Objects[cmbType.ItemIndex]);
    lstTest.OnDrawItem := P.DrawItem;
    lstTest.ItemHeight := P.ItemHeight;
    lstTest.Style := lbOwnerDrawFixed;
  end;
end;

procedure TfrmMain.btnAddClick(Sender: TObject);
begin
  lstTest.Items.Add(txtAdd.Text);
end;

procedure TfrmMain.btnDeleteClick(Sender: TObject);
begin
  lstTest.DeleteSelected;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  sR: TSearchRec;
  P: TPlugIn;
  Path: String;
begin
  FPlugIns := TList.Create;
  Path := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName)) + 'PlugIns\';
  if FindFirst(Path + '*.dll', faAnyFile, sR) = 0 then
  begin
    repeat
      try
        P := TPlugIn.Create(Path + sR.Name);
      except
        P := nil;
      end;
      if Assigned(P) then
      begin
        FPlugIns.Add(P);
        cmbType.AddItem(P.Description, P);
      end;
    until FindNext(sR) <> 0;
    FindClose(sR);
  end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var
  I: Integer;
begin
  lstTest.Style := lbStandard;
  for I := 0 to FPlugIns.Count - 1 do
    TPlugIn(FPlugIns[I]).Free;
  FPlugIns.Clear;
end;

end.
