library Vreme;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  SysUtils,
  Classes,
  Controls,
  Windows,
  StdCtrls,
  Graphics;

{$R *.res}

procedure DrawItem(cHandle: HDC; Index: Integer; iString: String; Rect: TRect; State: TOwnerDrawState); stdcall;
var
  I: Integer;
  X, Y: Integer;
  Canvas: TCanvas;
  Vreme: String;
begin
  Canvas := TCanvas.Create;
  Canvas.Handle := cHandle;
  Vreme := 'Iscrtano u: ' + TimetoStr(Time);
  if odSelected in State then
    Canvas.Brush.Color := clSkyBlue
  else
    Canvas.Brush.Color := clWindow;
  Canvas.Pen.Color := canvas.Brush.Color;
  Canvas.FillRect(Rect);
  Canvas.Font.Name := 'Tahoma';
  Canvas.Font.Height := -20;
  Canvas.Font.Color := clBlack;
  Canvas.TextOut(Rect.Left + 1, Rect.Top, iString);
  Canvas.Font.Height := -11;
  Canvas.Font.Color := clRed;
  X := Rect.Right - Canvas.TextWidth(Vreme) - 2;
  Y := Rect.Bottom - Canvas.TextHeight(Vreme) - 2;
  Canvas.TextOut(X, Y, Vreme);
  Canvas.Free;
end;

function GetDescription: String; stdcall;
begin
  Result := 'Vreme crtanja';
end;

function GetHeight: Integer; stdcall;
begin
  Result := 45;
end;

exports
  DrawItem,
  GetDescription,
  GetHeight;

begin
end.
